\input{../../include/schemes-reference}
\input{../../include/schemes}
\begin{document}
\begin{tikzpicture}[
    submatrix/.style = {draw = black, line width = \submatrixlinewidth},
    submatrixlabel/.style = {
      draw = black, fill = white, anchor = center, align = center,
      scale = \labelscale, inner sep = \labelinnersep,
      line width = \labellinewidth
    }
  ]
  % Top green and red lines.
  \draw[
    draw = green, line width = \sidelinewidth
  ] (-1.55 * \drawscale, 1.7 * \drawscale) node{}
  -- (0.45 * \drawscale, 1.7 * \drawscale);
  \draw[
    draw = red, line width = \sidelinewidth
  ] (0.55 * \drawscale, 1.7 * \drawscale) node{}
  -- (1.55 * \drawscale, 1.7 * \drawscale);
  % Left green and red lines.
  \draw[
    draw = green, line width = \sidelinewidth
  ] (-1.7 * \drawscale, 1.55 * \drawscale) node{}
  -- (-1.7 * \drawscale, -0.45 * \drawscale);
  \draw[
    draw = red, line width = \sidelinewidth
  ] (-1.7 * \drawscale, -0.55 * \drawscale) node{}
  -- (-1.7 * \drawscale, -1.55 * \drawscale);
  % Sparse/dense matrix.
  \node[
    matrix, draw = black, line width = \matrixlinewidth,
    inner sep = \matrixinnersep
  ] (FB) at (0, 0) {
    \draw[
      submatrix, pattern = fillin, pattern color = green
    ] (0, 0) node[anchor = west]{}
    -- (2 * \drawscale, 0) node[anchor = north]{}
    -- (0, 2 * \drawscale) node[anchor = north west]{}
    -- cycle;
    \node[submatrixlabel] (Avv) at (1 * \drawscale, 1 * \drawscale) {
      $L_{vv}$ \\ [-2mm]
      {\tiny \textit{\textbf{sparse}}} \\ [-2mm]
      {\tiny \textit{with fill-in}}
    }; &
    \draw[
      submatrix, pattern = dense, pattern color = orange
    ] (0, 0) rectangle ++(1 * \drawscale, 2 * \drawscale);
    \node[submatrixlabel] (AsvT) at (0.5 * \drawscale, 1 * \drawscale) {
      $Y$ \\ [-2mm]
      {\tiny \textit{\textbf{dense}}}
    }; \\ [-3mm]
    \draw[
      submatrix, pattern = sparse,
    ] (0, 0) rectangle ++(2 * \drawscale, 1 * \drawscale);
    \node[submatrixlabel] (Asv) at (1 * \drawscale, 0.5 * \drawscale) {
      $A_{sv}$ \\ [-2mm]
      {\tiny \textit{\textbf{sparse}}}
    }; &
    \draw[
      submatrix, pattern = dense, pattern color = red
    ] (0, 0) node[anchor = south west]{}
    -- (1 * \drawscale, 0) node[anchor = south east]{}
    -- (0, 1 * \drawscale) node[anchor = north west]{}
    -- cycle;
    \node[submatrixlabel] (Ass) at (0.5 * \drawscale, 0.5 * \drawscale) {
      $A_{ss}$ \\ [-2mm]
      {\tiny \textit{\textbf{dense}}}
    }; \\
  };
  \draw[
    {Stealth[length=5mm]}-, line width = \submatrixlinewidth
  ] (1.3 * \drawscale, 0.55 * \drawscale)
  -- (2.2 * \drawscale, 0.55 * \drawscale) node[submatrixlabel] {
    $\scriptscriptstyle (L_{vv}L_{vv}^T)^{-1}A_{sv}^T$
  };
  \draw[
    submatrix, pattern = dense, pattern color = black
  ] (2 * \drawscale, -1.55 * \drawscale) node[anchor = west]{}
  -- (3 * \drawscale, -1.55 * \drawscale) node[anchor = north]{}
  -- (2 * \drawscale, -0.55 * \drawscale) node[anchor = north west]{}
  -- cycle;
  \node[submatrixlabel] (Z) at (2.4 * \drawscale, -1.05 * \drawscale) {
    $Z = A_{sv}Y$ \\ [-2mm]
    {\tiny \textit{\textbf{dense}}}
  };
\end{tikzpicture}
\end{document}
